## skrooge 2.29.0

=== CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE ROOT ::..")
set(CMAKE_TRY_COMPILE_TARGET_TYPE "STATIC_LIBRARY")
PROJECT(skrooge)


SET(QT_MIN_VERSION "5.12.0")
IF (CMAKE_PREFIX_PATH)
ELSE (CMAKE_PREFIX_PATH)
    SET(CMAKE_PREFIX_PATH "/usr/lib/x86_64-linux-gnu/cmake")
ENDIF  (CMAKE_PREFIX_PATH)
IF (CMAKE_LIBRARY_ARCHITECTURE)
ELSE (CMAKE_LIBRARY_ARCHITECTURE)
    SET(CMAKE_LIBRARY_ARCHITECTURE "x86_64-linux-gnu")
ENDIF (CMAKE_LIBRARY_ARCHITECTURE)
MESSAGE( STATUS "     CMAKE_LIBRARY_ARCHITECTURE   :  " ${CMAKE_LIBRARY_ARCHITECTURE})

# QT6 MIGRATION
#add_compile_definitions(QT_DISABLE_DEPRECATED_BEFORE=0x050F00)

OPTION(SKG_BUILD_TEST "Build the test" ON)
OPTION(SKG_DESIGNER   "Build designer library" ON)
OPTION(SKG_WEBENGINE  "Build Skrooge with WebEngine (can not be used with SKG_WEBKIT)" OFF)
OPTION(SKG_WEBKIT  "Build Skrooge with WebKit (can not be used with SKG_WEBENGINE)" ON)
OPTION(SKG_DBUS  "Build with DBUS" ON)
IF(WIN32)
    SET(SKG_WEBENGINE OFF)
    SET(SKG_WEBKIT OFF)
    SET(SKG_DESIGNER OFF)
    SET(SKG_KF_5100 OFF)
ENDIF(WIN32)

CMAKE_MINIMUM_REQUIRED(VERSION 3.16.0)
IF(POLICY CMP0063)
  CMAKE_POLICY(SET CMP0063 NEW)
ENDIF(POLICY CMP0063)
 
FIND_PACKAGE(ECM 1.7.0 REQUIRED NO_MODULE)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${skrooge_SOURCE_DIR}/cmake/modules)
INCLUDE(ECMInstallIcons)
INCLUDE(KDEInstallDirs)
INCLUDE(KDECompilerSettings)
INCLUDE(KDECMakeSettings)
INCLUDE(FeatureSummary)
INCLUDE(CheckCXXCompilerFlag)
INCLUDE(GenerateExportHeader)
INCLUDE(ECMSetupVersion)
INCLUDE(ECMGenerateHeaders)
INCLUDE(CMakePackageConfigHelpers)
INCLUDE(KDEFrameworkCompilerSettings)

FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} NO_MODULE REQUIRED Core Widgets Script Sql Test PrintSupport Svg Xml Concurrent Qml QuickWidgets)

IF(SKG_WEBENGINE)
    FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} NO_MODULE REQUIRED WebEngineWidgets)
    IF(SKG_WEBKIT)
        MESSAGE( FATAL_ERROR "You can not use both SKG_WEBENGINE and SKG_WEBKIT. You have to enable one and disable the other." )
    ENDIF(SKG_WEBKIT)
ENDIF(SKG_WEBENGINE)
IF(SKG_WEBKIT)
    FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} NO_MODULE REQUIRED WebKitWidgets)
ENDIF(SKG_WEBKIT)

IF(SKG_DBUS)
    MESSAGE( STATUS "     DBUS enabled")
    FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} NO_MODULE REQUIRED DBus)
ELSE(SKG_DBUS)
    MESSAGE( STATUS "     DBUS disabled")
ENDIF(SKG_DBUS)

IF(SKG_DESIGNER)
  FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} NO_MODULE REQUIRED Designer )
  FIND_PACKAGE(KF5 5.0.0 REQUIRED COMPONENTS
    DesignerPlugin        # Tier 3
  )  
ELSE(SKG_DESIGNER)
  SET(SKG_BUILD_TEST OFF)
ENDIF(SKG_DESIGNER)

FIND_PACKAGE(Grantlee5 0.5 REQUIRED)

FIND_PACKAGE(KF5 5.86.0 REQUIRED COMPONENTS
  Archive               # Tier 1
  Config                # Tier 1
  CoreAddons            # Tier 1
  I18n                  # Tier 1
  ItemViews             # Tier 1
  WidgetsAddons         # Tier 1
  WindowSystem          # Tier 1
  Completion            # Tier 2
  JobWidgets            # Tier 2
  ConfigWidgets         # Tier 3
  IconThemes            # Tier 3
  KIO                   # Tier 3
  NewStuffCore          # Tier 3
  NewStuff              # Tier 3
  NewStuffQuick         # Tier 3
  Parts                 # Tier 3
  Wallet                # Tier 3
  XmlGui                # Tier 3
)

FIND_PACKAGE(KF5DocTools)

FIND_PACKAGE(PkgConfig REQUIRED)
PKG_CHECK_MODULES(SQLCIPHER REQUIRED sqlcipher)
MESSAGE( STATUS "     Mode SQLCIPHER enabled")
MESSAGE( STATUS "     SQLCIPHER INCLUDE   :  " ${SQLCIPHER_INCLUDE_DIRS})
SET(SQLITE_LIBRARIES ${SQLCIPHER_LIBRARIES})
SET(SQLITE_INCLUDE_DIR ${SQLCIPHER_INCLUDE_DIRS})
link_directories(${SQLCIPHER_LIBRARY_DIRS})

SET_PACKAGE_PROPERTIES(Sqlcipher PROPERTIES DESCRIPTION "Support for encryption"
                       URL "https://www.zetetic.net/sqlcipher/"
                       TYPE REQUIRED)

SET(GRANTLEE_VERSION ${Grantlee5_VERSION_MAJOR}.${Grantlee5_VERSION_MINOR}.${Grantlee5_VERSION_PATCH})
MESSAGE( STATUS "     GRANTLEE VERSION    : " ${GRANTLEE_VERSION})

SET(SKG_VERSION "2.29.0")
SET(SKG_BETA "")
SET(SOVERSION 2)

IF (CMAKE_BUILD_TYPE)
ELSE (CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE profile)
#"release": optimized for speed, no debug symbols or debug messages
#"relwithdebinfo": optimized for speed, debug symbols for backtraces
#"debug": optimized, but debuggable
#"debugfull": no optimizations, full debug support
#"profile": adds coverage flags to debugfull
#"none": the build flags are manually set using the CMAKE_CXX_FLAGS option.
ENDIF (CMAKE_BUILD_TYPE)

FIND_PROGRAM(SKG_BASH bash)
MARK_AS_ADVANCED(SKG_BASH)

SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
SET(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
MESSAGE( STATUS "     QT                  : " ${Qt5_VERSION} )
MESSAGE( STATUS "     KF5                 : " ${KF5_VERSION} )
MESSAGE( STATUS "     PROJECT_SOURCE_DIR  : " ${PROJECT_SOURCE_DIR} )
MESSAGE( STATUS "     PROJECT_BINARY_DIR  : " ${PROJECT_BINARY_DIR} )
MESSAGE( STATUS "     CMAKE_BUILD_TYPE    : " ${CMAKE_BUILD_TYPE} )
MESSAGE( STATUS "     CMAKE_MODULE_PATH   : " ${CMAKE_MODULE_PATH} )
MESSAGE( STATUS "     CMAKE_INSTALL_PREFIX: " ${CMAKE_INSTALL_PREFIX} )
MESSAGE( STATUS "     SKG_BUILD_TEST      : " ${SKG_BUILD_TEST} )
MESSAGE( STATUS "     SKG_DESIGNER        : " ${SKG_DESIGNER} )
MESSAGE( STATUS "     SKG_WEBENGINE       : " ${SKG_WEBENGINE} )
MESSAGE( STATUS "     SKG_WEBKIT          : " ${SKG_WEBKIT} )
MESSAGE( STATUS "     SKG_DBUS            : " ${SKG_DBUS} )
MESSAGE( STATUS "     KDE_INSTALL_QTPLUGINDIR : " ${KDE_INSTALL_QTPLUGINDIR})

#IF(CMAKE_BUILD_TYPE MATCHES "profile")
#  MESSAGE( STATUS "     TRACES              : All traces activated")
  #add_definitions(-DSKGFULLTRACES)
#ELSE(CMAKE_BUILD_TYPE MATCHES "profile")
#  IF(CMAKE_BUILD_TYPE MATCHES "debug" OR SKG_BETA MATCHES "BETA")
    MESSAGE( STATUS "     TRACES              : Some traces activated")
#  ELSE(CMAKE_BUILD_TYPE MATCHES "debug" OR SKG_BETA MATCHES "BETA")
#    MESSAGE( STATUS "     TRACES              : All traces disabled")
#    add_definitions(-DSKGNOTRACES)
#  ENDIF(CMAKE_BUILD_TYPE MATCHES "debug" OR SKG_BETA MATCHES "BETA")
#ENDIF(CMAKE_BUILD_TYPE MATCHES "profile")

# FIX: Qt was built with -reduce-relocations
IF(Qt5_POSITION_INDEPENDENT_CODE)
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
ENDIF(Qt5_POSITION_INDEPENDENT_CODE)

ADD_DEFINITIONS(-DSKGVERSION=${SKG_VERSION}${SKG_BETA})
REMOVE_DEFINITIONS(-DQT_NO_CAST_FROM_ASCII)

#Correction bug 207249 vvvv
IF(CMAKE_COMPILER_IS_GNUCXX)
    CHECK_CXX_COMPILER_FLAG("-Wlogical-op" WLOGICALOP)
    IF(WLOGICALOP)
        ADD_COMPILE_OPTIONS(-Wlogical-op)
    ENDIF(WLOGICALOP)
    
    CHECK_CXX_COMPILER_FLAG("-Wnoexcept" WNOEXCEPT)
    IF(WNOEXCEPT)
        ADD_COMPILE_OPTIONS(-Wnoexcept)
    ENDIF(WNOEXCEPT)    

    ADD_COMPILE_OPTIONS(-std=c++0x -pedantic -Wall -Wextra -Wno-variadic-macros -Wparentheses -Wmissing-braces -Wcast-align -Wcast-qual -Wformat=2 -Winit-self -Wmissing-include-dirs -Woverloaded-virtual -Wsign-promo -Wstrict-null-sentinel -Wundef -Wno-unused)
    #  ADD_COMPILE_OPTIONS(-Wstrict-overflow=5  -Wshadow  -Wctor-dtor-privacy  -Wshadow -Wold-style-cast -Wswitch-default -Wredundant-decls)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)
#Correction bug 207249 ^^^^

#Default installation path
SET(CMAKE_INSTALL_PREFIX ${BUILD_DIR})

IF(KF5_VERSION VERSION_GREATER_EQUAL 5.100.0)
    MESSAGE( STATUS "     KF5 >= 5.100.0")
    ADD_DEFINITIONS(-DSKG_KF_5100=ON)
ENDIF()

# Win32 specific configuration
IF(WIN32)
    ADD_DEFINITIONS(-DSKG_PLATFORM_WIN32)
    IF(CMAKE_COMPILER_IS_GNUCXX)
	SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc -Wl,--export-all-symbols" CACHE STRING "" FORCE)
    ENDIF(CMAKE_COMPILER_IS_GNUCXX)
    
    IF (CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
        ADD_DEFINITIONS( -DQT_DEBUG )
    ENDIF (CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)    
ELSE(WIN32)
#To solve Bug 209912:"ldd -u <library>""
#does not work on MACOS, must be done manually		SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed" CACHE STRING "" FORCE)
ENDIF(WIN32)
MESSAGE(STATUS "     CMAKE_SHARED_LINKER_FLAGS : ${CMAKE_SHARED_LINKER_FLAGS}")

#ADD_SUBDIRECTORY
ADD_SUBDIRECTORY(skgsqlcipher)
ADD_SUBDIRECTORY(skgbasemodeler)
ADD_SUBDIRECTORY(skgbankmodeler)
ADD_SUBDIRECTORY(skgbasegui)
ADD_SUBDIRECTORY(skgbankgui)

IF(SKG_DESIGNER)
    ADD_SUBDIRECTORY(skgbaseguidesigner)
    ADD_SUBDIRECTORY(skgbankguidesigner)    
ENDIF(SKG_DESIGNER)

ADD_SUBDIRECTORY(plugins)
ADD_SUBDIRECTORY(images)

IF(SKG_BUILD_TEST AND NOT WIN32)
    ADD_SUBDIRECTORY(tests)
ENDIF(SKG_BUILD_TEST AND NOT WIN32)

IF(KF5DocTools_FOUND)
  ADD_SUBDIRECTORY(doc)
ENDIF(KF5DocTools_FOUND)

#Main application
ADD_SUBDIRECTORY(skrooge)
ADD_SUBDIRECTORY(skroogeconvert)

# ADD_SUBDIRECTORY(skrooge-companion)
#TODO(STEPHANE MANKOWSKI) KF5 ADD_SUBDIRECTORY(skroogeakonadi)

CONFIGURE_FILE(scripts/addNewPlugin.sh.in scripts/addNewPlugin.sh @ONLY)
CONFIGURE_FILE(scripts/addNewImportPlugin.sh.in scripts/addNewImportPlugin.sh @ONLY)

#DOXYGEN
ADD_CUSTOM_TARGET(apidox "doxygen" "${PROJECT_SOURCE_DIR}/Doxyfile")

#ASTYLE
CONFIGURE_FILE(scripts/astyle.sh.in scripts/astyle.sh @ONLY)
ADD_CUSTOM_TARGET(astyle "scripts/astyle.sh")

#GENERATE SPLASH SCREEN
CONFIGURE_FILE(scripts/generateSplash.sh.in scripts/generateSplash.sh @ONLY)
ADD_CUSTOM_TARGET(splash "scripts/generateSplash.sh")

#STATIC CODE CHECKS
CONFIGURE_FILE(scripts/codecheck.sh.in scripts/codecheck.sh @ONLY)
ADD_CUSTOM_TARGET(codecheck "scripts/codecheck.sh")

#FULL
CONFIGURE_FILE(scripts/full.sh scripts/full.sh @ONLY)

#PO files
FIND_PACKAGE(KF5I18n CONFIG REQUIRED)
KI18N_INSTALL(po)

FIND_PACKAGE(KF5DocTools CONFIG)
IF(KF5DocTools_FOUND)
    KDOCTOOLS_INSTALL(po)
ENDIF()
  
FEATURE_SUMMARY(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== images/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE IMAGES ::..")

PROJECT(images)

ADD_SUBDIRECTORY( logos )

#GENERATE SPLASH SCREEN
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/splash.svg.in ${PROJECT_BINARY_DIR}/splash.svg @ONLY)

INSTALL(FILES splash.png DESTINATION ${KDE_INSTALL_DATADIR}/skrooge/images)

=== skgbankgui/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBANKGUI ::..")

PROJECT(SKGBANKGUI)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

IF(SKG_WEBENGINE)
    MESSAGE( STATUS "     Mode WebEngine")
    ADD_DEFINITIONS(-DSKG_WEBENGINE=${SKG_WEBENGINE})
ENDIF(SKG_WEBENGINE)
IF(SKG_WEBKIT)
    MESSAGE( STATUS "     Mode Webkit")
    ADD_DEFINITIONS(-DSKG_WEBKIT=${SKG_WEBKIT})
ENDIF(SKG_WEBKIT)

SET(skgbankgui_SRCS
    skgobjectmodel.cpp
    skgquerycreator.cpp
    skgpredicatcreator.cpp
    skgquerydelegate.cpp
    skgunitcombobox.cpp
)

SET(LIBS Qt5::Xml skgbankmodeler skgbasemodeler skgbasegui)
IF(SKG_WEBENGINE)
    SET(LIBS ${LIBS} Qt5::WebEngineWidgets)
ENDIF(SKG_WEBENGINE)
IF(SKG_WEBKIT)
    SET(LIBS ${LIBS} Qt5::WebKitWidgets)
ENDIF(SKG_WEBKIT)
IF(KActivities_FOUND)
    MESSAGE( STATUS "     KActivity FOUND" )
    SET(LIBS ${LIBS} KF5::Activities)
endif (KActivities_FOUND)

ki18n_wrap_ui(skgbankgui_SRCS skgquerycreator.ui)

ADD_LIBRARY(skgbankgui SHARED ${skgbankgui_SRCS})
TARGET_LINK_LIBRARIES(skgbankgui LINK_PUBLIC ${LIBS})
SET_TARGET_PROPERTIES(skgbankgui PROPERTIES VERSION ${SKG_VERSION} SOVERSION ${SOVERSION} )
GENERATE_EXPORT_HEADER(skgbankgui BASE_NAME skgbankgui)

########### install files ###############
INSTALL(TARGETS skgbankgui ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}  LIBRARY NAMELINK_SKIP  )
INSTALL(DIRECTORY icons_breeze/ DESTINATION ${KDE_INSTALL_ICONDIR}/breeze/actions/22 FILES_MATCHING PATTERN "*.svgz")
INSTALL(DIRECTORY icons_breeze-dark/ DESTINATION ${KDE_INSTALL_ICONDIR}/breeze-dark/actions/22 FILES_MATCHING PATTERN "*.svgz")

ECM_INSTALL_ICONS(ICONS
    icons_hicolor/16-actions-skrooge_credit_card.png
    icons_hicolor/16-actions-skrooge_less.png
    icons_hicolor/16-actions-skrooge_more.png
    icons_hicolor/16-actions-skrooge_much_less.png
    icons_hicolor/16-actions-skrooge_much_more.png
    icons_hicolor/16-actions-skrooge_type.png
    icons_hicolor/22-actions-skrooge_credit_card.png
    icons_hicolor/22-actions-skrooge_less.png
    icons_hicolor/22-actions-skrooge_more.png
    icons_hicolor/22-actions-skrooge_much_less.png
    icons_hicolor/22-actions-skrooge_much_more.png
    icons_hicolor/22-actions-skrooge_type.png
    icons_hicolor/32-actions-skrooge_credit_card.png
    icons_hicolor/32-actions-skrooge_less.png
    icons_hicolor/32-actions-skrooge_more.png
    icons_hicolor/32-actions-skrooge_much_less.png
    icons_hicolor/32-actions-skrooge_much_more.png
    icons_hicolor/32-actions-skrooge_type.png
    icons_hicolor/48-actions-skrooge_credit_card.png
    icons_hicolor/48-actions-skrooge_less.png
    icons_hicolor/48-actions-skrooge_more.png
    icons_hicolor/48-actions-skrooge_much_less.png
    icons_hicolor/48-actions-skrooge_much_more.png
    icons_hicolor/48-actions-skrooge_type.png
    icons_hicolor/64-actions-skrooge_credit_card.png
    icons_hicolor/64-actions-skrooge_less.png
    icons_hicolor/64-actions-skrooge_more.png
    icons_hicolor/64-actions-skrooge_much_less.png
    icons_hicolor/64-actions-skrooge_much_more.png
    icons_hicolor/64-actions-skrooge_type.png
    icons_hicolor/128-actions-skrooge_credit_card.png
    icons_hicolor/128-actions-skrooge_less.png
    icons_hicolor/128-actions-skrooge_more.png
    icons_hicolor/128-actions-skrooge_much_less.png
    icons_hicolor/128-actions-skrooge_much_more.png
    icons_hicolor/128-actions-skrooge_type.png
    icons_hicolor/256-actions-skrooge_credit_card.png
    icons_hicolor/256-actions-skrooge_less.png
    icons_hicolor/256-actions-skrooge_more.png
    icons_hicolor/256-actions-skrooge_much_less.png
    icons_hicolor/256-actions-skrooge_much_more.png
    icons_hicolor/256-actions-skrooge_type.png
    icons_hicolor/512-actions-skrooge_credit_card.png
    icons_hicolor/512-actions-skrooge_less.png
    icons_hicolor/512-actions-skrooge_more.png
    icons_hicolor/512-actions-skrooge_much_less.png
    icons_hicolor/512-actions-skrooge_much_more.png
    icons_hicolor/512-actions-skrooge_type.png 
    icons_hicolor/sc-actions-skrooge_credit_card.svgz
    icons_hicolor/sc-actions-skrooge_less.svgz
    icons_hicolor/sc-actions-skrooge_more.svgz
    icons_hicolor/sc-actions-skrooge_much_less.svgz
    icons_hicolor/sc-actions-skrooge_much_more.svgz
    icons_hicolor/sc-actions-skrooge_type.svgz
    DESTINATION ${KDE_INSTALL_ICONDIR}
    THEME hicolor
)

=== skgbankguidesigner/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBANKGUIDESIGNER ::..")

PROJECT(SKGBANKGUI)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

IF(SKG_WEBENGINE)
    MESSAGE( STATUS "     Mode WebEngine")
    ADD_DEFINITIONS(-DSKG_WEBENGINE=${SKG_WEBENGINE})
ENDIF(SKG_WEBENGINE)
IF(SKG_WEBKIT)
    MESSAGE( STATUS "     Mode Webkit")
    ADD_DEFINITIONS(-DSKG_WEBKIT=${SKG_WEBKIT})
ENDIF(SKG_WEBKIT)

SET(skgbankguidesigner_SRCS ${skgbankgui_SRCS}
    skgquerycreatordesignerplugin.cpp
    skgbkwidgetcollectiondesignerplugin.cpp
    skgpredicatcreatordesignerplugin.cpp
    skgunitcomboboxdesignerplugin.cpp
)

SET(LIBS Qt5::Designer skgbankgui)

IF(SKG_WEBENGINE)
    SET(LIBS ${LIBS} Qt5::WebEngineWidgets)
ENDIF(SKG_WEBENGINE)
IF(SKG_WEBKIT)
    SET(LIBS ${LIBS} Qt5::WebKitWidgets)
ENDIF(SKG_WEBKIT)

ADD_LIBRARY(skgbankguidesigner SHARED ${skgbankguidesigner_SRCS})
TARGET_LINK_LIBRARIES(skgbankguidesigner LINK_PUBLIC ${LIBS})
GENERATE_EXPORT_HEADER(skgbankguidesigner BASE_NAME skgbankguidesigner)

########### install files ###############
IF(WIN32)
    INSTALL(TARGETS skgbankguidesigner LIBRARY ARCHIVE DESTINATION ${KDE_INSTALL_PLUGINDIR}/designer )
ELSE(WIN32)
    INSTALL(TARGETS skgbankguidesigner LIBRARY DESTINATION ${KDE_INSTALL_PLUGINDIR}/designer )
ENDIF(WIN32)

=== skgbaseguidesigner/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBASEGUIDESIGNER ::..")

PROJECT(SKGBASEGUIDESIGNER)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

IF(SKG_WEBENGINE)
    MESSAGE( STATUS "     Mode WebEngine")
    ADD_DEFINITIONS(-DSKG_WEBENGINE=${SKG_WEBENGINE})
ENDIF(SKG_WEBENGINE)
IF(SKG_WEBKIT)
    MESSAGE( STATUS "     Mode Webkit")
    ADD_DEFINITIONS(-DSKG_WEBKIT=${SKG_WEBKIT})
ENDIF(SKG_WEBKIT)

SET(skgbaseguidesigner_SRCS 
    skgwidgetcollectiondesignerplugin.cpp
    skgtabwidgetdesignerplugin.cpp
    skgtablewidgetdesignerplugin.cpp
    skgtableviewdesignerplugin.cpp
    skgfilteredtableviewdesignerplugin.cpp
    skgtreeviewdesignerplugin.cpp
    skgcomboboxdesignerplugin.cpp
    skgcolorbuttondesignerplugin.cpp
    skgwidgetselectordesignerplugin.cpp
    skgwebviewdesignerplugin.cpp
    skgzoomselectordesignerplugin.cpp
    skgcalculatoreditdesignerplugin.cpp
    skggraphicsviewdesignerplugin.cpp
    skgshowdesignerplugin.cpp
    skgtablewithgraphdesignerplugin.cpp
    skgdateeditdesignerplugin.cpp
    skgprogressbardesignerplugin.cpp
    skgperiodeditdesignerplugin.cpp
    skgsimpleperiodeditdesignerplugin.cpp
)

SET(LIBS Qt5::Designer skgbasegui)

IF(SKG_WEBENGINE)
    SET(LIBS ${LIBS} Qt5::WebEngineWidgets)
ENDIF(SKG_WEBENGINE)
IF(SKG_WEBKIT)
    SET(LIBS ${LIBS} Qt5::WebKitWidgets)
ENDIF(SKG_WEBKIT)

ADD_LIBRARY(skgbaseguidesigner SHARED ${skgbaseguidesigner_SRCS})
TARGET_LINK_LIBRARIES(skgbaseguidesigner LINK_PUBLIC ${LIBS})
GENERATE_EXPORT_HEADER(skgbaseguidesigner BASE_NAME skgbaseguidesigner)

########### install files ###############
IF(WIN32)
    INSTALL(TARGETS skgbaseguidesigner LIBRARY ARCHIVE DESTINATION ${KDE_INSTALL_PLUGINDIR}/designer )
ELSE(WIN32)
    INSTALL(TARGETS skgbaseguidesigner LIBRARY DESTINATION ${KDE_INSTALL_PLUGINDIR}/designer )
ENDIF(WIN32)

=== skgbasemodeler/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBASEMODELER ::..")

PROJECT(SKGBASEMODELER)
IF(SKG_DBUS)
    MESSAGE( STATUS "     DBUS enabled")
    ADD_DEFINITIONS(-DSKG_DBUS=${SKG_DBUS})
ELSE(SKG_DBUS)
    MESSAGE( STATUS "     DBUS disabled")
ENDIF(SKG_DBUS)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

FIND_PACKAGE(Qca-qt5 2.1.0 REQUIRED)                   
SET_PACKAGE_PROPERTIES(Qca-qt5 PROPERTIES DESCRIPTION "Support for encryption"
                       URL "https://download.kde.org/stable/qca-qt5"
                       TYPE REQUIRED)                       

INCLUDE_DIRECTORIES(${SQLCIPHER_INCLUDE_DIRS})
                       
IF ( Qca-qt5_FOUND )
   ADD_DEFINITIONS( -DQCA2 )
ENDIF()

SET(skgbasemodeler_SRCS
   skgobjectbase.cpp
   skgnamedobject.cpp
   skgnodeobject.cpp
   skgpropertyobject.cpp
   skgdocument.cpp
   skgdocumentprivate.cpp
   skgtransactionmng.cpp
   skgservices.cpp
   skgerror.cpp
   skgtraces.cpp
   skgadvice.cpp
   skgreport.cpp
   skgtreemap.cpp
 )

#build a shared library
ADD_LIBRARY(skgbasemodeler SHARED ${skgbasemodeler_SRCS})

#need to link to some other libraries ? just add them here
SET_TARGET_PROPERTIES(skgbasemodeler PROPERTIES VERSION ${SKG_VERSION} SOVERSION ${SOVERSION} )
TARGET_LINK_LIBRARIES(skgbasemodeler LINK_PUBLIC KF5::I18n KF5::IconThemes KF5::ConfigWidgets KF5::CoreAddons
    Qt5::Core Qt5::Gui Qt5::Sql Qt5::Script Qt5::Xml Qt5::DBus Qt5::Concurrent qca-qt5
    Grantlee5::Templates KF5::KIOCore
    ${SQLCIPHER_LIBRARIES} )

GENERATE_EXPORT_HEADER(skgbasemodeler BASE_NAME skgbasemodeler)

########### install files ###############
INSTALL(TARGETS skgbasemodeler ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}  LIBRARY NAMELINK_SKIP )

=== skgsqlcipher/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: SKGSQLCIPHER ::..")

PROJECT(skgsqlcipher)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skgsqlcipher_sources skgsqlcipherdriverplugin.cpp qsql_sqlite.cpp)

ADD_LIBRARY(libskgsqlcipher MODULE ${skgsqlcipher_sources})
TARGET_INCLUDE_DIRECTORIES(libskgsqlcipher PRIVATE ${Qt5Sql_PRIVATE_INCLUDE_DIRS} ${SQLCIPHER_INCLUDE_DIRS})
TARGET_LINK_LIBRARIES(libskgsqlcipher Qt5::Sql ${SQLCIPHER_LIBRARIES})

GENERATE_EXPORT_HEADER(libskgsqlcipher BASE_NAME skgsqlcipher)

########### install files ###############
INSTALL(TARGETS libskgsqlcipher DESTINATION ${KDE_INSTALL_QTPLUGINDIR}/sqldrivers)

=== skrooge/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKROOGE ::..")

PROJECT(SKROOGE)

IF(SKG_DBUS)
    MESSAGE( STATUS "     DBUS enabled")
    ADD_DEFINITIONS(-DSKG_DBUS=${SKG_DBUS})
ELSE(SKG_DBUS)
    MESSAGE( STATUS "     DBUS disabled")
ENDIF(SKG_DBUS)

IF(SKG_WEBENGINE)
    MESSAGE( STATUS "     Mode WebEngine")
    ADD_DEFINITIONS(-DSKG_WEBENGINE=${SKG_WEBENGINE})
ENDIF(SKG_WEBENGINE)
IF(SKG_WEBKIT)
    MESSAGE( STATUS "     Mode Webkit")
    ADD_DEFINITIONS(-DSKG_WEBKIT=${SKG_WEBKIT})
ENDIF(SKG_WEBKIT)

FIND_PACKAGE(KF5 5.0.0 REQUIRED COMPONENTS
  DBusAddons               # Tier 1
)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skrooge_SRCS
   main.cpp
 )
INCLUDE(ECMAddAppIcon)
file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/icons_hicolor/[0-9][0-9]-apps-skrooge.png")
ECM_ADD_APP_ICON(skrooge_SRCS ICONS
    "${CMAKE_CURRENT_SOURCE_DIR}/icons_hicolor/256-apps-skrooge.png"
    "${CMAKE_CURRENT_SOURCE_DIR}/icons_hicolor/128-apps-skrooge.png"
    ${ICONS_SRCS})

ADD_EXECUTABLE(skrooge ${skrooge_SRCS})

TARGET_LINK_LIBRARIES(skrooge KF5::DBusAddons skgbasemodeler skgbasegui skgbankmodeler skgbankgui)

########### install files ###############
INSTALL(TARGETS skrooge ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )
INSTALL(PROGRAMS org.kde.skrooge.desktop  DESTINATION  ${KDE_INSTALL_APPDIR} )
INSTALL(FILES org.kde.skrooge.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )
INSTALL(DIRECTORY theme DESTINATION ${KDE_INSTALL_DATADIR}/skrooge FILES_MATCHING PATTERN "*.css"
PATTERN ".svn" EXCLUDE
PATTERN "CMakeFiles" EXCLUDE
PATTERN "Testing" EXCLUDE)
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skrooge.notifyrc  DESTINATION  ${KDE_INSTALL_KNOTIFY5RCDIR} )

ECM_INSTALL_ICONS(ICONS
    icons_hicolor/16-apps-skrooge-black.png
    icons_hicolor/16-apps-skrooge.png
    icons_hicolor/16-mimetypes-application-x-skg.png
    icons_hicolor/16-mimetypes-application-x-skgc.png
    icons_hicolor/22-apps-skrooge-black.png
    icons_hicolor/22-apps-skrooge.png
    icons_hicolor/22-mimetypes-application-x-skg.png
    icons_hicolor/22-mimetypes-application-x-skgc.png
    icons_hicolor/32-apps-skrooge-black.png
    icons_hicolor/32-apps-skrooge.png
    icons_hicolor/32-mimetypes-application-x-skg.png
    icons_hicolor/32-mimetypes-application-x-skgc.png
    icons_hicolor/48-apps-skrooge-black.png
    icons_hicolor/48-apps-skrooge.png
    icons_hicolor/48-mimetypes-application-x-skg.png
    icons_hicolor/48-mimetypes-application-x-skgc.png 
    icons_hicolor/64-apps-skrooge-black.png
    icons_hicolor/64-apps-skrooge.png
    icons_hicolor/64-mimetypes-application-x-skg.png
    icons_hicolor/64-mimetypes-application-x-skgc.png
    icons_hicolor/128-apps-skrooge-black.png
    icons_hicolor/128-apps-skrooge.png
    icons_hicolor/128-mimetypes-application-x-skg.png
    icons_hicolor/128-mimetypes-application-x-skgc.png
    icons_hicolor/256-apps-skrooge-black.png
    icons_hicolor/256-apps-skrooge.png
    icons_hicolor/256-mimetypes-application-x-skg.png
    icons_hicolor/256-mimetypes-application-x-skgc.png
    icons_hicolor/512-apps-skrooge-black.png
    icons_hicolor/512-apps-skrooge.png
    icons_hicolor/512-mimetypes-application-x-skg.png
    icons_hicolor/512-mimetypes-application-x-skgc.png
    icons_hicolor/sc-apps-skrooge-black.svgz
    icons_hicolor/sc-apps-skrooge-initial.svgz
    icons_hicolor/sc-apps-skrooge.svgz
    icons_hicolor/sc-mimetypes-application-x-skg.svgz
    icons_hicolor/sc-mimetypes-application-x-skgc.svgz
    DESTINATION ${KDE_INSTALL_ICONDIR}
    THEME hicolor
)
if (NOT SHARED_MIME_INFO_MINIMUM_VERSION)
  set(SHARED_MIME_INFO_MINIMUM_VERSION "0.23")
endif (NOT SHARED_MIME_INFO_MINIMUM_VERSION)

find_package(SharedMimeInfo REQUIRED)

install(FILES x-skg.xml DESTINATION ${KDE_INSTALL_MIMEDIR})
update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})

=== skroogeakonadi/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: SKROOGEAKONADI ::..")
PROJECT(skroogeakonadi)
IF(SKG_DBUS)
    MESSAGE( STATUS "     DBUS enabled")
    ADD_DEFINITIONS(-DSKG_DBUS=${SKG_DBUS})
ELSE(SKG_DBUS)
    MESSAGE( STATUS "     DBUS disabled")
ENDIF(SKG_DBUS)

FIND_PACKAGE (KdepimLibs REQUIRED)
INCLUDE(MacroLibrary)
INCLUDE(MacroOptionalAddSubdirectory)
INCLUDE(CheckIncludeFiles)

FIND_PROGRAM(XSLTPROC_EXECUTABLE xsltproc)
MACRO_LOG_FEATURE(XSLTPROC_EXECUTABLE "xsltproc" "The command line XSLT processor from libxslt" "https://xmlsoft.org/XSLT/" FALSE "" "Needed for building Akonadi resources. Recommended.")

if (XSLTPROC_EXECUTABLE)
  # generates a D-Bus interface description from a KConfigXT file
  macro( kcfg_generate_dbus_interface _kcfg _name )
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_name}.xml
      COMMAND ${XSLTPROC_EXECUTABLE} --stringparam interfaceName ${_name}
              ${KDEPIMLIBS_DATA_DIR}/akonadi-kde/kcfg2dbus.xsl
              ${_kcfg}
              > ${CMAKE_CURRENT_BINARY_DIR}/${_name}.xml
      DEPENDS ${KDEPIMLIBS_DATA_DIR}/akonadi-kde/kcfg2dbus.xsl
              ${_kcfg}
    )
  endmacro( kcfg_generate_dbus_interface )
endif (XSLTPROC_EXECUTABLE)

if(WIN32)
    set(LIB_INSTALL_DIR ${LIB_INSTALL_DIR}
                        RUNTIME DESTINATION ${BIN_INSTALL_DIR}
                        LIBRARY DESTINATION ${LIB_INSTALL_DIR}
                        ARCHIVE DESTINATION ${LIB_INSTALL_DIR} )
endif(WIN32)

set(KDE4_ICON_DIR ${KDE4_INSTALL_DIR}/share/icons)

include_directories(
    ${KDE4_INCLUDES}
    ${KDEPIMLIBS_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/skgbasemodeler
    ${CMAKE_SOURCE_DIR}/${skgbankmodeler}
)

set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${KDE4_ENABLE_EXCEPTIONS}" )


########### next target ###############

set( skroogeakonadiresource_SRCS
  skroogeakonadiresource.cpp
)

install(FILES org.kde.skroogeakonadiresource.desktop DESTINATION "${CMAKE_INSTALL_PREFIX}/share/akonadi/agents" )

KCONFIG_ADD_KCFG_FILES(skroogeakonadiresource_SRCS settings.kcfgc)
KCFG_GENERATE_DBUS_INTERFACE(${CMAKE_CURRENT_SOURCE_DIR}/skroogeakonadiresource.kcfg org.kde.Akonadi.skroogeakonadi.Settings)
QT5_ADD_DBUS_ADAPTOR(skroogeakonadiresource_SRCS
  ${CMAKE_CURRENT_BINARY_DIR}/org.kde.Akonadi.skroogeakonadi.Settings.xml settings.h Settings
)

#TODO(Stephane MANKOWSKI) KF5 ADD_EXECUTABLE(akonadi_skroogeakonadi_resource RUN_UNINSTALLED ${skroogeakonadiresource_SRCS})
ADD_EXECUTABLE(akonadi_skroogeakonadi_resource ${skroogeakonadiresource_SRCS})

TARGET_LINK_LIBRARIES(akonadi_skroogeakonadi_resource ${KDE4_AKONADI_LIBS} ${KDEPIMLIBS_KCALCORE_LIBS} KF5::KIOWidgets Qt5::Core Qt5::DBus skgbasemodeler skgbankmodeler)

INSTALL(TARGETS akonadi_skroogeakonadi_resource ${INSTALL_TARGETS_DEFAULT_ARGS}  LIBRARY NAMELINK_SKIP)

=== skroogeconvert/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKROOGECONVERT ::..")

PROJECT(SKROOGECONVERT)

INCLUDE(ECMMarkNonGuiExecutable)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skroogeconvert_SRCS
   main.cpp
 )
ADD_EXECUTABLE(skroogeconvert ${skroogeconvert_SRCS})
ECM_MARK_NONGUI_EXECUTABLE(skroogeconvert)

TARGET_LINK_LIBRARIES(skroogeconvert Qt5::Widgets skgbasemodeler skgbankmodeler)

########### install files ###############
INSTALL(TARGETS skroogeconvert ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

=== templates/skrooge_xxx/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_XXX ::..")

PROJECT(plugin_xxx)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skrooge_xxx_SRCS
	skgxxxplugin.cpp
	skgxxxpluginwidget.cpp)

ki18n_wrap_ui(skrooge_xxx_SRCS skgxxxpluginwidget_base.ui skgxxxpluginwidget_pref.ui)
kconfig_add_kcfg_files(skrooge_xxx_SRCS skgxxx_settings.kcfgc )

ADD_LIBRARY(skrooge_xxx MODULE ${skrooge_xxx_SRCS})
TARGET_LINK_LIBRARIES(skrooge_xxx KF5::Parts skgbasemodeler skgbasegui)

########### install files ###############
INSTALL(TARGETS skrooge_xxx DESTINATION ${KDE_INSTALL_QTPLUGINDIR})
INSTALL(FILES ${PROJECT_SOURCE_DIR}/org.kde.skrooge-plugin-xxx.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR})
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skrooge_xxx.rc  DESTINATION  ${KDE_INSTALL_KXMLGUI5DIR}/skrooge_xxx )
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skgxxx_settings.kcfg  DESTINATION  ${KDE_INSTALL_KCFGDIR} )

ECM_INSTALL_ICONS(${KDE_INSTALL_ICONDIR})

=== tests/skgbankguitest/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2022 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2022 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBANKGUITEST ::..")

PROJECT(SKBBASEMODELERTEST)

ADD_DEFINITIONS(-DQT_GUI_LIB)
LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/tests/skgbasemodelertest )

#Make executables
ADD_EXECUTABLE(skgtestpredicatcreator skgtestpredicatcreator.cpp)
ADD_EXECUTABLE(skgtestmainpanel skgtestmainpanel.cpp)
ADD_EXECUTABLE(skgtestactions skgtestactions.cpp)
ADD_EXECUTABLE(skgtesttreeview skgtesttreeview.cpp)
ADD_EXECUTABLE(skgtestbankwidgets skgtestbankwidgets.cpp)
ADD_EXECUTABLE(skgtestmodel skgtestmodel.cpp modeltest.cpp)


TARGET_LINK_LIBRARIES(skgtestpredicatcreator  Qt5::Gui Qt5::Core Qt5::Test skgbasemodeler skgbankmodeler skgbankgui skgbasegui)
TARGET_LINK_LIBRARIES(skgtestmainpanel  Qt5::Gui Qt5::Core Qt5::Test skgbasemodeler skgbankmodeler skgbankgui skgbasegui)
TARGET_LINK_LIBRARIES(skgtestactions  Qt5::Gui Qt5::Core Qt5::Test skgbasemodeler skgbankmodeler skgbankgui skgbasegui)
TARGET_LINK_LIBRARIES(skgtesttreeview Qt5::Core KF5::KIOWidgets Qt5::Test skgbankmodeler skgbasemodeler skgbankgui skgbasegui)
TARGET_LINK_LIBRARIES(skgtestbankwidgets Qt5::Core KF5::KIOWidgets Qt5::Test skgbankmodeler skgbasemodeler skgbankguidesigner skgbasegui)
TARGET_LINK_LIBRARIES(skgtestmodel Qt5::Core KF5::KIOWidgets Qt5::Test skgbankmodeler skgbasemodeler skgbankgui skgbasegui)

#Add test
ENABLE_TESTING()
ADD_TEST(NAME skgtestpredicatcreator COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skgtestpredicatcreator.sh)
ADD_TEST(NAME skgtestmainpanel COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skgtestmainpanel.sh)
ADD_TEST(NAME skgtestactions COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skgtestactions.sh)
ADD_TEST(NAME skgtesttreeview COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skgtesttreeview.sh)
ADD_TEST(NAME skgtestbankwidgets COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skgtestbankwidgets.sh)
ADD_TEST(NAME skgtestmodel COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skgtestmodel.sh)

#TODO: TO LONG ADD_TEST(NAME skgtestskrooge COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skgtestskrooge.sh)

INCLUDE(CTest)

=== debian/changelog ===
skrooge (2.29.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump almost all the KF packages to 5.86.0
    - add libqt5xmlpatterns5-dev
  * Bump Standards-Version to 4.6.2, no changes required.
  * Modernize building:
    - add the dh-sequence-kf5 build dependency to use the kf5 addon
      automatically, removing pkg-kde-tools
    - add the dh-sequence-python3 build dependency to use the python3 addon
      automatically, removing dh-python
    - drop all the manually specified addons and buildsystem for dh
  * Backport upstream commit 309c0d74d210e77635d8b3d6189dffae887380df, and
    commit 5cfbfaaaa7c6e46a2e406819c5dc6197a9a5c870 to fix the build on any
    non-amd64 architecture; patches upstream_Revert-cmake-issue.patch,
    and upstream_cmake-drop-bogus-CMAKE_TRY_COMPILE_TARGET_TYPE.patch.

 -- Pino Toscano <pino@debian.org>  Thu, 16 Feb 2023 00:08:31 +0100

=== debian/control ===
Source: skrooge
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: cmake (>= 3.16.0~),
               debhelper-compat (= 13),
               dh-sequence-kf5,
               dh-sequence-python3,
               extra-cmake-modules (>= 1.7.0),
               qtbase5-dev (>= 5.12.0~),
               qtbase5-private-dev (>= 5.12.0~),
               libqt5svg5-dev (>= 5.12.0~),
               qttools5-dev (>= 5.12.0~),
               libqt5webkit5-dev (>= 5.12.0~),
               qtdeclarative5-dev (>= 5.12.0~),
               libqt5xmlpatterns5-dev (>= 5.12.0~),
               libkf5activities-dev,
               libkf5archive-dev (>= 5.86.0~),
               libkf5completion-dev (>= 5.86.0~),
               libkf5config-dev (>= 5.86.0~),
               libkf5configwidgets-dev (>= 5.86.0~),
               libkf5coreaddons-dev (>= 5.86.0~),
               libkf5dbusaddons-dev,
               libkf5doctools-dev,
               libkf5guiaddons-dev,
               libkf5i18n-dev (>= 5.86.0~),
               libkf5iconthemes-dev (>= 5.86.0~),
               libkf5itemviews-dev (>= 5.86.0~),
               libkf5jobwidgets-dev (>= 5.86.0~),
               libkf5kio-dev (>= 5.86.0~),
               libkf5newstuff-dev (>= 5.86.0~),
               libkf5notifications-dev,
               libkf5notifyconfig-dev,
               libkf5parts-dev (>= 5.86.0~),
               libkf5runner-dev,
               libkf5wallet-dev (>= 5.86.0~),
               libkf5widgetsaddons-dev (>= 5.86.0~),
               libkf5windowsystem-dev (>= 5.86.0~),
               libkf5xmlgui-dev (>= 5.86.0~),
               libgrantlee5-dev (>= 0.5),
               libqca-qt5-2-dev,
               xsltproc,
               libofx-dev,
               libsqlcipher-dev,
               pkg-config,
               python3:any,
               shared-mime-info,
               gettext,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://skrooge.org/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/skrooge.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/skrooge

Package: skrooge
Architecture: any
Depends: libqca-qt5-2-plugins,
         libqt5sql5-sqlite,
         skrooge-common (= ${source:Version}),
         kinit,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: poppler-utils
Suggests: aqbanking-tools (>= 5.6.10)
Description: personal finance manager for KDE
 Skrooge allows you to manage your personal finances. It is intended to be used
 by individuals who want to keep track of their incomes, expenses and
 investments. Its philosophy is to stay simple and intuitive.
 .
 Here is the list of Skrooge main features:
  * QIF, CSV, KMyMoney, Skrooge,  import/export
  * OFX, QFX, GnuCash, Grisbi, HomeBank import
  * Advanced Graphical Reports
  * Several tabs to help you organize your work
  * Infinite undo/redo
  * Instant filtering on operations and reports
  * Infinite categories levels
  * Mass update of operations
  * Scheduled operations
  * Track refund of your expenses
  * Automatically process operations based on search conditions
  * Multi currencies
  * Dashboard

Package: skrooge-common
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
Description: Skrooge architecture independent files
 Skrooge allows you to manage your personal finances. It is intended to be used
 by individuals who want to keep track of their incomes, expenses and
 investments. Its philosophy is to stay simple and intuitive.
 .
 This package contains architecture independent files needed for Skrooge to run
 properly. It also provides Skrooge documentation. Therefore, unless you
 have 'skrooge' package installed, you will hardly find this package useful.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --buildsystem=kf5 -- -DSKG_BUILD_TEST=OFF -DSKG_DESIGNER=OFF

override_dh_auto_test:

override_dh_python3:
	dh_python3 -p skrooge-common /usr/share/skrooge

## skrooge 2.30.0

=== debian/changelog ===
skrooge (2.30.0-2) unstable; urgency=medium

  * Get the right grantlee dependency for the shipped plugin:
    - add the dh-sequence-grantlee build dependency
    - use the ${grantlee:Depends} substvar

 -- Pino Toscano <pino@debian.org>  Sat, 05 Aug 2023 19:20:22 +0200

skrooge (2.30.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Revert-cmake-issue.patch: drop, backported from upstream
    - upstream_cmake-drop-bogus-CMAKE_TRY_COMPILE_TARGET_TYPE.patch:
      drop, backported from upstream
  * Pass -DSKG_WEBENGINE=OFF to cmake to keep using QtWebKit for now.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Mon, 03 Jul 2023 08:26:38 +0200
